unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SctCtrl, SctRep, SctVar, AcePage, StdCtrls, Buttons, SctBtn, ExtCtrls,
  Db, DBTables;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    SctReport1: TSctReport;
    ReportPage: TSctGrouppage;
    ReportHeaderBand: TSctBand;
    ReportHeaderBandlevel: TSctLevel;
    PageHeaderBand: TSctBand;
    PageHeaderBandlevel: TSctLevel;
    DetailBand: TSctBand;
    DetailBandlevel: TSctLevel;
    PageFooterBand: TSctBand;
    PageFooterBandlevel: TSctLevel;
    ReportFooterBand: TSctBand;
    ReportFooterBandlevel: TSctLevel;
    SctReportButton1: TSctReportButton;
    svarDateTime: TSctDateTimeVar;
    svarPage: TSctPageVar;
    DataSourceGuide: TSctDataSourceGuide;
    table1NAMEVar: TSctDBVar;
    table1APPTDATEVar: TSctDBVar;
    table1APPTTIMEVar: TSctDBVar;
    table1DURATIONVar: TSctDBVar;
    Group: TSctGroup;
    GroupHeader: TSctBand;
    GroupHeaderLevel: TSctLevel;
    GroupFooter: TSctBand;
    GroupFooterLevel: TSctLevel;
    varlabel: TSctvarlabel;
    SctCustomLabel1: TSctCustomLabel;
    varlabel1: TSctvarlabel;
    varlabel2: TSctvarlabel;
    procedure SctCustomLabel1Draw(lb: TSctLabel; AceCanvas: TObject;
      Rect: TRect);
    procedure GroupHeaderAfterPrint(Band: TSctBand);
    procedure varlabelBeforePrint(lb: TSctLabel);
    procedure SctReportButton1BeforeRun(PageSetup: TObject);
  private
    { Private declarations }
    col1, col2, col3: integer;
  public
    { Public declarations }
  end;

function TimeToPos(TimeVal: integer): integer;
function TimeTotext(TimeVal: integer): string;

var
  Form1: TForm1;

implementation

{$R *.DFM}
uses aceout;

procedure TForm1.SctCustomLabel1Draw(lb: TSctLabel; AceCanvas: TObject;
  Rect: TRect);
var
  TimeVal :integer;
begin
  TimeVal := 800;
  while TimeVal <= 1700 do
  begin
    if ((TimeVal mod 100) = 0) then
    begin
      TAceCanvas(AceCanvas).MoveTo(Rect.Left,Rect.Top + TimeToPos(TimeVal));
      TAceCanvas(AceCanvas).LineTo(Rect.Left+700,Rect.Top + TimeToPos(TimeVal));
    end;
    TAceCanvas(AceCanvas).TextOut(Rect.Left,Rect.Top + TimeToPos(TimeVal)
       ,TimeToText(TimeVal));
    TimeVal := TimeVal + 15;
    if ((TimeVal mod 100) = 60) then TimeVal := TimeVal + 40;   
  end;

end;

function TimeToPos(TimeVal: integer): integer;
begin
  Result := TimeVal - 800;
  Result := 96 * (Result div 100) + ((TimeVal mod 100)*24) div 15;
end;

function TimeTotext(TimeVal: integer): string;
var
  Temp: integer;
begin
  Temp := TimeVal;
  if Temp >= 1300 then Temp := Temp - 1200;
  Result := FormatFloat('#0:00',Temp);
end;

procedure TForm1.GroupHeaderAfterPrint(Band: TSctBand);
begin
  col1 := 800;
  col2 := 800;
  col3 := 800;
end;

procedure TForm1.varlabelBeforePrint(lb: TSctLabel);
var
  Temp: integer;
begin
  lb.Top := TimeToPos(table1APPTTIMEVar.AsInteger);
  lb.Height := table1DURATIONVar.AsInteger * 24 div 15;
  Temp := table1APPTTIMEVar.AsInteger
        + (100 * (table1DURATIONVar.AsInteger div 60))
        + (table1DURATIONVar.AsInteger mod 60);
  if col1 <= table1APPTTIMEVar.AsInteger then
    begin
      lb.Left := 100;
      col1 := Temp;
    end
  else if col2 <= table1APPTTIMEVar.AsInteger then
    begin
      lb.Left := 300;
      col2 := Temp;
    end
  else if col3 <= table1APPTTIMEVar.AsInteger then
    begin
      lb.Left := 500;
      col3 := Temp;
    end;
end;

procedure TForm1.SctReportButton1BeforeRun(PageSetup: TObject);
begin
  GroupHeader.Height := 0;
  DetailBand.Height := 0;
end;

end.
